﻿'1、实现位棋盘（坐标是一维的，因为用一维坐标表示棋盘可以节省很多不必要的y*l+x计算。）
Public Class mBitBoard
    '用bitarray代替byte数组，提高读写速度。（bitarray内部实现是用integer数组，每一个元素是32字节，所以寻址速度要比用byte数组快很多）
    '0=白方，1=黑方，2=空
    Private wBitArr As BitArray
    Private bBitArr As BitArray
    '15*15的棋盘。
    Sub New()
        wBitArr = New BitArray(225)
        bBitArr = New BitArray(225)
    End Sub

    '设置棋子
    Sub [Set](index As Integer, value As Integer)
        If value = 0 Then
            wBitArr.Set(index, True)
        ElseIf value = 1 Then
            bBitArr.Set(index, True)
        Else
            bBitArr.Set(index, False)
            wBitArr.Set(index, False)
        End If
    End Sub

    '获取棋子
    Function [Get](index As Integer) As Integer
        If wBitArr.Get(index) Then Return 0
        If bBitArr.Get(index) Then Return 1
        Return 2
    End Function

End Class
